VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsCL30vb"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Const BufferMaxSize = 32768 '    
Const BufferMax = BufferMaxSize - 4096 '    

Dim strBufferOut As String '   
Dim strBufferIn As String '   
Dim strDataOut As String '  
Dim strDataIn As String '  (    )
Dim strPwd As String '

Dim lngDataInSize As Long '  
Dim lngBufferInLen As Long '   
Dim lngOperType As Long  '  1-encode,2-decode,3-compress
Dim lngDirectionType As Long ' : 1-SS,2-FF,3-SF,4-FS

Dim lngPosition As Long '     

Dim lngEnvelope As Long '  ""
Dim lngAlgo As Long ' 
    
Dim lngBytesToPush As Long ' ,   ""  
Dim lngBytesPushed As Long ' , ""  
Dim lngBytesPopped As Long ' , ""  

Dim lngParamRequired As Long '   

Dim intFileNo(0 To 1) As Integer ' / - 
Dim strFileName(0 To 1) As String ' / - 

Dim Errcode As Long ',  

Public Property Let my_prpStrPwd(NewVal As String)
strPwd = NewVal
End Property
Public Property Let my_prpLngOperType(NewVal As Long) '1-encode,2-decode,3-compress
lngOperType = NewVal
End Property
Public Property Let my_prpLngDirectionType(NewVal As Long) '1-SS,2-FF,3-SF,4-FS
lngDirectionType = NewVal
End Property
Public Property Let my_prpLngAlgo(NewVal As Long)
'0-non
'1-CRYPT_ALGO_DES                  ' DES
'2-CRYPT_ALGO_3DES                 ' Triple DES
'3-CRYPT_ALGO_IDEA                 ' IDEA
'4-CRYPT_ALGO_CAST                 ' CAST-128
'5-CRYPT_ALGO_RC2                  ' RC2
'6-CRYPT_ALGO_RC4                  ' RC4
'7-CRYPT_ALGO_RC5                  ' RC5
'8-CRYPT_ALGO_AES                  ' AES
'9-CRYPT_ALGO_BLOWFISH             ' Blowfish
'10-CRYPT_ALGO_SKIPJACK             ' Skipjack

lngAlgo = NewVal
End Property

Public Property Let my_prpStrFileIn(NewVal As String)
strFileName(0) = NewVal
End Property
Public Property Let my_prpStrFileOut(NewVal As String)
strFileName(1) = NewVal
End Property
Public Property Let my_prpStrDataIn(NewVal As String)
strDataIn = NewVal
End Property
Public Property Get my_prpStrDataOut() As String
my_prpStrDataOut = strDataOut
End Property

Private Sub my_subInfoPrepare()

' ,    
strDataOut = ""

Select Case lngDirectionType
Case 1, 3
    lngDataInSize = Len(strDataIn)
Case 2, 4
    intFileNo(0) = FreeFile
    Open strFileName(0) For Binary Access Read As intFileNo(0)
    
    lngDataInSize = LOF(intFileNo(0))
End Select

'         
'***************Buffers
If lngDataInSize <= 0 Then
    Beep
    Exit Sub
End If

If lngDataInSize > BufferMax Then
    lngBufferInLen = BufferMax
Else
    lngBufferInLen = lngDataInSize
End If
'***************Buffers

Select Case lngDirectionType
Case 2, 3
    intFileNo(1) = FreeFile
    Open strFileName(1) For Output Access Write As intFileNo(1)
    Close intFileNo(1)        ' file is empty now
    Open strFileName(1) For Binary Access Write As intFileNo(1)
End Select

End Sub
Private Sub my_subInfoRelease()
' 

Select Case lngDirectionType
Case 2, 4
    Close intFileNo(0)
End Select

Select Case lngDirectionType
Case 2, 3
    Close intFileNo(1)
End Select

With Me
    .my_prpLngAlgo = 0
    .my_prpLngDirectionType = 0
    .my_prpLngOperType = 0
    .my_prpStrDataIn = ""
    .my_prpStrFileIn = ""
    .my_prpStrFileOut = ""
    .my_prpStrPwd = ""
End With

End Sub

Private Sub my_subEnvelopeDestroy()
'  

Errcode = cryptDestroyEnvelope(lngEnvelope)
If Errcode < CRYPT_OK Then
    Err.Raise 1000 - Errcode, , "cryptDestroyEnvelope returned " & Str(Errcode)
End If

End Sub

Private Sub my_subEnvelopePrepare()
'   _
     _
  

Select Case lngOperType
Case 1 '
    '   (  lngAlgo  CRYPT_OPTION_ENCR_ALGO)
    Errcode = cryptSetAttribute(CRYPT_UNUSED, CRYPT_OPTION_ENCR_ALGO, lngAlgo)
    If Errcode < CRYPT_OK Then
        Err.Raise 1000 - Errcode, , "cryptSetAttributeALGO returned " & Str(Errcode)
    End If
    
    '  (:CRYPT_FORMAT_CRYPTLIB)
    Errcode = cryptCreateEnvelope(lngEnvelope, CRYPT_UNUSED, CRYPT_FORMAT_CRYPTLIB)
    If Errcode < CRYPT_OK Then
        Err.Raise 1000 - Errcode, , "cryptCreateEnvelope returned " & Str(Errcode)
    End If
    
    '    (  strPwd  CRYPT_ENVINFO_PASSWORD)
    Errcode = cryptSetAttributeString(lngEnvelope, CRYPT_ENVINFO_PASSWORD, strPwd, Len(strPwd))
    If Errcode < CRYPT_OK Then
        Err.Raise 1000 - Errcode, , "cryptSetAttributeString returned " & Str(Errcode)
    End If
Case 2 '

    '  (:CRYPT_FORMAT_AUTO)
    Errcode = cryptCreateEnvelope(lngEnvelope, CRYPT_UNUSED, CRYPT_FORMAT_AUTO)
    If Errcode < CRYPT_OK Then
        Err.Raise 1000 - Errcode, , "cryptCreateEnvelope returned " & Str(Errcode)
    End If
Case 3 '
    
    '  (:CRYPT_FORMAT_CRYPTLIB)
    Errcode = cryptCreateEnvelope(lngEnvelope, CRYPT_UNUSED, CRYPT_FORMAT_CRYPTLIB)
    If Errcode < CRYPT_OK Then
        Err.Raise 1000 - Errcode, , "cryptCreateEnvelope returned " & Str(Errcode)
    End If

    '   (  CRYPT_UNUSED  CRYPT_ENVINFO_COMPRESSION)
    Errcode = cryptSetAttribute(lngEnvelope, CRYPT_ENVINFO_COMPRESSION, CRYPT_UNUSED)
    If Errcode < CRYPT_OK Then
        Err.Raise 1000 - Errcode, , "cryptSetAttribute returned " & Str(Errcode)
    End If
Case Else
    Exit Sub
End Select


End Sub


Private Function my_funInfoCheck() As Boolean '    

Select Case lngOperType
Case 1
    If Not (lngAlgo >= 1 And lngAlgo <= 10) Then
        MsgBox " "
        Exit Function
    End If
Case 2
Case 3
Case Else
    MsgBox "  "
    Exit Function
End Select

Select Case lngDirectionType
Case 2, 4
    If Dir(strFileName(0)) = "" Then
        MsgBox "    "
        Exit Function
    End If
Case 1, 3
    If Len(strDataIn) = 0 Then
        MsgBox "   "
        Exit Function
    End If
Case Else
    Exit Function
End Select

Select Case lngDirectionType
Case 2, 3
    If Len(strFileName(1)) = 0 Then
        MsgBox "   "
        Exit Function
    End If

    If Dir(strFileName(1)) <> "" Then
        If MsgBox( _
        "  " _
        & strFileName(1) _
        & "  . ?", _
        vbYesNo) = vbNo Then Exit Function
    End If
End Select

If Len(strPwd) = 0 Then
    strPwd = InputBox("  ")
    If Len(strPwd) = 0 Then Exit Function
End If

my_funInfoCheck = True

End Function
Private Function my_funOperateData() As Boolean '1-ss,2-ff,3-sf,4-fs

If Not my_funInfoCheck Then Exit Function

Call my_subEnvelopePrepare ' 
Call my_subInfoPrepare ' 

    lngPosition = 0
    
    Do
        '  
        Select Case lngDirectionType
        Case 1, 3
            strBufferIn = Mid(strDataIn, lngPosition + 1, lngBufferInLen)
        Case 2, 4
            'Select Case lngDirectionType
            'Case 2, 4
            Seek intFileNo(0), lngPosition + 1
            'End Select
            strBufferIn = Input(lngBufferInLen, intFileNo(0))
        End Select
        
        '      
        lngBytesPushed = 0
        ' now push the data from file into the cryptlib envelope
        Errcode = cryptPushData(lngEnvelope, strBufferIn, lngBufferInLen, lngBytesPushed)
        
        If Errcode < CRYPT_OK Then
        '  
            If Errcode = CRYPT_ENVELOPE_RESOURCE _
            And lngOperType = 2 _
            And cryptSetAttribute(lngEnvelope, CRYPT_ENVINFO_CURRENT_COMPONENT, CRYPT_CURSOR_FIRST) = CRYPT_OK Then
                '      
                ' This happens only in case of decoding a file (never on encoding)
                If (cryptGetAttribute(lngEnvelope, CRYPT_ENVINFO_CURRENT_COMPONENT, lngParamRequired) >= CRYPT_OK) _
                And (lngParamRequired = CRYPT_ENVINFO_PASSWORD) Then
                    '    - 
                    '    ( )
                    ' other cases not handled here!
                    Call cryptSetAttributeString(lngEnvelope, CRYPT_ENVINFO_PASSWORD, strPwd, Len(strPwd))
                End If
            ElseIf Errcode <> CRYPT_ERROR_OVERFLOW Then
                Err.Raise 1000 - Errcode, , "cryptPushData returned " & Str(Errcode)
            End If
        End If
        
        '  lngBytesPushed    
        '    
        lngPosition = lngPosition + lngBytesPushed
            
        If lngBytesPushed <> lngBufferInLen Then
        '    <>   _
         .    
            Call my_subInfoPop
        End If
        
        '      
        If lngPosition >= lngDataInSize Then Exit Do
    Loop
    
' ,      
'*******************end of input
Errcode = cryptFlushData(lngEnvelope)  'indicate end of data to cryptlib
If Errcode < CRYPT_OK Then
    Err.Raise 1000 - Errcode, , "cryptPushData returned " & Str(Errcode)
End If
'*******************end of input
    
    '   ,   _
         0
    Do
        Call my_subInfoPop
        If lngBytesPopped = 0 Then Exit Do
    Loop

Call my_subInfoRelease ' ,  
Call my_subEnvelopeDestroy ' 

my_funOperateData = True
End Function

Private Sub my_subInfoPop()

'  
strBufferOut = String(BufferMaxSize, " ")
lngBytesPopped = 0
' pop rest of data out of the envelope
'       
Errcode = cryptPopData(lngEnvelope, strBufferOut, BufferMaxSize, lngBytesPopped)
If (Errcode < CRYPT_OK) And (Errcode <> CRYPT_ERROR_OVERFLOW) Then
    Err.Raise 1000 - Errcode, , "cryptPopData returned " & Str(Errcode)
End If

'  lngBytesPopped -   
If lngBytesPopped > 0 Then
    ' write the info to the output file
    strBufferOut = Left(strBufferOut, lngBytesPopped)
    '       _
          
    Select Case lngDirectionType
    Case 1, 4
        strDataOut = strDataOut & strBufferOut
    Case 2, 3
        Put intFileNo(1), , strBufferOut
    End Select
End If

End Sub

Private Sub Class_Initialize()
'     _
(   )
Call cryptInit
End Sub
Private Sub Class_Terminate()
'     _
(   )
Call cryptEnd
End Sub

Function my_funOper_ESS( _
    strSource As String, _
    lngAlgorithm As Long, _
    strPassword As String) As Boolean   '    

With Me
    .my_prpLngDirectionType = 1
    .my_prpLngOperType = 1
    .my_prpLngAlgo = lngAlgorithm
    .my_prpStrDataIn = strSource
    .my_prpStrPwd = strPassword
End With

my_funOper_ESS = my_funOperateData

End Function
Function my_funString_ESS( _
    strSource As String, _
    lngAlgorithm As Long, _
    strPassword As String) As String   '    
If my_funOper_ESS(strSource, lngAlgorithm, strPassword) Then _
    my_funString_ESS = Me.my_prpStrDataOut
End Function

Function my_funOper_DSS( _
    strSource As String, _
    strPassword As String) As Boolean '    

With Me
    .my_prpLngDirectionType = 1
    .my_prpLngOperType = 2
    .my_prpStrDataIn = strSource
    .my_prpStrPwd = strPassword
End With

my_funOper_DSS = my_funOperateData

End Function
Function my_funString_DSS( _
    strSource As String, _
    strPassword As String) As String  '    
If my_funOper_DSS(strSource, strPassword) Then _
    my_funString_DSS = Me.my_prpStrDataOut
End Function

Function my_funOper_EFF( _
    strFileNameSource As String, _
    strFileNameTarget As String, _
    lngAlgorithm As Long, _
    strPassword As String) As Boolean '    

With Me
    .my_prpLngDirectionType = 2
    .my_prpLngOperType = 1
    .my_prpLngAlgo = lngAlgorithm
    .my_prpStrFileIn = strFileNameSource
    .my_prpStrFileOut = strFileNameTarget
    .my_prpStrPwd = strPassword
End With

my_funOper_EFF = my_funOperateData

End Function
Function my_funOper_DFF( _
    strFileNameSource As String, _
    strFileNameTarget As String, _
    strPassword As String) As Boolean '    

With Me
    .my_prpLngDirectionType = 2
    .my_prpLngOperType = 2
    .my_prpStrFileIn = strFileNameSource
    .my_prpStrFileOut = strFileNameTarget
    .my_prpStrPwd = strPassword
End With

my_funOper_DFF = my_funOperateData

End Function
Function my_funOper_ESF( _
    strSource As String, _
    strFileNameTarget As String, _
    lngAlgorithm As Long, _
    strPassword As String) As Boolean '    

With Me
    .my_prpLngDirectionType = 3
    .my_prpLngOperType = 1
    .my_prpLngAlgo = lngAlgorithm
    .my_prpStrDataIn = strSource
    .my_prpStrFileOut = strFileNameTarget
    .my_prpStrPwd = strPassword
End With

my_funOper_ESF = my_funOperateData

End Function
Function my_funOper_DSF( _
    strSource As String, _
    strFileNameTarget As String, _
    strPassword As String) As Boolean '    

With Me
    .my_prpLngDirectionType = 3
    .my_prpLngOperType = 2
    .my_prpStrDataIn = strSource
    .my_prpStrFileOut = strFileNameTarget
    .my_prpStrPwd = strPassword
End With

my_funOper_DSF = my_funOperateData

End Function
Function my_funOper_EFS( _
    strFileNameSource As String, _
    lngAlgorithm As Long, _
    strPassword As String) As Boolean '    

With Me
    .my_prpLngDirectionType = 4
    .my_prpLngOperType = 1
    .my_prpLngAlgo = lngAlgorithm
    .my_prpStrFileIn = strFileNameSource
    .my_prpStrPwd = strPassword
End With

my_funOper_EFS = my_funOperateData

End Function
Function my_funString_EFS( _
    strFileNameSource As String, _
    lngAlgorithm As Long, _
    strPassword As String) As String  '    
If my_funOper_EFS(strFileNameSource, lngAlgorithm, strPassword) Then _
    my_funString_EFS = Me.my_prpStrDataOut
End Function


Function my_funOper_DFS( _
    strFileNameSource As String, _
    strPassword As String) As Boolean '    

With Me
    .my_prpLngDirectionType = 4
    .my_prpLngOperType = 2
    .my_prpStrFileIn = strFileNameSource
    .my_prpStrPwd = strPassword
End With

my_funOper_DFS = my_funOperateData

End Function
Function my_funString_DFS( _
    strFileNameSource As String, _
    strPassword As String) As String '    
If my_funOper_DFS(strFileNameSource, strPassword) Then _
    my_funString_DFS = Me.my_prpStrDataOut
End Function



